const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MaintenanceDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const maintenance = await db.maintenance.create(
      {
        id: data.id || undefined,

        type: data.type || null,
        scheduled_at: data.scheduled_at || null,
        odometer: data.odometer || null,
        cost: data.cost || null,
        notes: data.notes || null,
        attachments: data.attachments || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await maintenance.setTenant(data.tenant || null, {
      transaction,
    });

    await maintenance.setVehicle(data.vehicle || null, {
      transaction,
    });

    await maintenance.setAgences(data.agences || null, {
      transaction,
    });

    return maintenance;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const maintenanceData = data.map((item, index) => ({
      id: item.id || undefined,

      type: item.type || null,
      scheduled_at: item.scheduled_at || null,
      odometer: item.odometer || null,
      cost: item.cost || null,
      notes: item.notes || null,
      attachments: item.attachments || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const maintenance = await db.maintenance.bulkCreate(maintenanceData, {
      transaction,
    });

    // For each item created, replace relation files

    return maintenance;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const maintenance = await db.maintenance.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.type !== undefined) updatePayload.type = data.type;

    if (data.scheduled_at !== undefined)
      updatePayload.scheduled_at = data.scheduled_at;

    if (data.odometer !== undefined) updatePayload.odometer = data.odometer;

    if (data.cost !== undefined) updatePayload.cost = data.cost;

    if (data.notes !== undefined) updatePayload.notes = data.notes;

    if (data.attachments !== undefined)
      updatePayload.attachments = data.attachments;

    updatePayload.updatedById = currentUser.id;

    await maintenance.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await maintenance.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.vehicle !== undefined) {
      await maintenance.setVehicle(
        data.vehicle,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await maintenance.setAgences(
        data.agences,

        { transaction },
      );
    }

    return maintenance;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const maintenance = await db.maintenance.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of maintenance) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of maintenance) {
        await record.destroy({ transaction });
      }
    });

    return maintenance;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const maintenance = await db.maintenance.findByPk(id, options);

    await maintenance.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await maintenance.destroy({
      transaction,
    });

    return maintenance;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const maintenance = await db.maintenance.findOne(
      { where },
      { transaction },
    );

    if (!maintenance) {
      return maintenance;
    }

    const output = maintenance.get({ plain: true });

    output.tenant = await maintenance.getTenant({
      transaction,
    });

    output.vehicle = await maintenance.getVehicle({
      transaction,
    });

    output.agences = await maintenance.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.vehicles,
        as: 'vehicle',

        where: filter.vehicle
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.vehicle
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  plate_number: {
                    [Op.or]: filter.vehicle
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.notes) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('maintenance', 'notes', filter.notes),
        };
      }

      if (filter.attachments) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'maintenance',
            'attachments',
            filter.attachments,
          ),
        };
      }

      if (filter.scheduled_atRange) {
        const [start, end] = filter.scheduled_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            scheduled_at: {
              ...where.scheduled_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            scheduled_at: {
              ...where.scheduled_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.odometerRange) {
        const [start, end] = filter.odometerRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            odometer: {
              ...where.odometer,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            odometer: {
              ...where.odometer,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.costRange) {
        const [start, end] = filter.costRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            cost: {
              ...where.cost,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            cost: {
              ...where.cost,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.type) {
        where = {
          ...where,
          type: filter.type,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.maintenance.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('maintenance', 'type', query),
        ],
      };
    }

    const records = await db.maintenance.findAll({
      attributes: ['id', 'type'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['type', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.type,
    }));
  }
};
